#pragma once
#include <windows.h>
#include <windowsx.h>
#include <shlwapi.h>

#pragma intrinsic(memcmp,memcpy,memset)
#define T(x) TEXT(x)
#define elemof(x) (sizeof(x)/sizeof(*(x)))
#define nobreak
#pragma warning(disable:4200)

//duplink.cpp
void _cdecl println(const TCHAR*format,...);
extern BOOLEAN(_stdcall*CreateSymbolicLink)(const TCHAR*,const TCHAR*,DWORD);

//buildtree.cpp
struct FileTree{	// sizeof = 56 (0x38) + X
 int iName;	// Index des Datei/Verzeichnisnamens in <path>
 unsigned Attr;
 ULONGLONG CreationTime,LastAccessTime,LastWriteTime,Size;
 const FileTree*next,*prev,*parent,*sub;	// <sub> nur bei Verzeichnis
 TCHAR path[];	// voller Pfad (mit L'\' als Trenner)
 static FileTree*newItem(const TCHAR*parentpath,const WIN32_FIND_DATA* =0);
 static FileTree*newTree(const FileTree*);
 const FileTree*locate(const TCHAR*path) const;
 const FileTree**flattenFiles(const FileTree** =0) const;
 int comparefunc(const FileTree*) const;
 static int _cdecl comparefunc(const void*p1,const void*p2) {
	return (*(const FileTree**)p1)->comparefunc(*(const FileTree**)p2);}
 void duplinkAll(const FileTree*base);
 void duplink(const FileTree*const ref,const void*const content);
 static struct Count{
  unsigned files,dirs,links,equals;
  ULONGLONG bytes,equalBytes;
 }c;
 const TCHAR*name() const {return path+iName;}
 int depth() const;
 int hiddenDirs() const;
};

extern FileTree*root,**list;
extern HANDLE treeheap;

// dupfind.cpp
unsigned markDup(FileTree**list,unsigned len);
unsigned linkDup(FileTree**list,unsigned len);
